/*
Program...: Flash5SocketClient.java
Programmer: Michael Thomas - thomasma@us.ibm.com


Updates:

*/

import java.io.*;
import java.net.*;
import java.util.*;

//############################################################################################
public class Flash5SocketClient extends Thread {
//############################################################################################

  
  private final String STRCLIENTVERSION = "1.0.0";

  private final String STRSERVER_VALIDRESPONSE_CODE = "1";

  private final String STRSERVER_INVALIDRESPONSE_MSG = "Invalid request";
  private final String STRSERVER_INVALIDRESPONSE_CODE = "-1";
  
  private final static String ELEMENT_ACTION       = "action=\"";
  private final static String ELEMENT_DATA       = "data=\"";

  private Socket socket;                                        
  private String strIp;

  private BufferedReader objInStream;                
  private PrintWriter objOutStream;

//-------------------------------------------------------------------------------------
public Flash5SocketClient(Socket socket) {
//-------------------------------------------------------------------------------------

  System.out.println( "---Client: In constructor.  (Client Version: " + STRCLIENTVERSION + ")" );

  this.socket = socket;
  this.strIp = socket.getInetAddress().getHostAddress();
  
  try {
    objOutStream = new PrintWriter(socket.getOutputStream(), true);
    objInStream  = new BufferedReader(new InputStreamReader(socket.getInputStream()));
  } catch(IOException ioe) {
    System.out.println("Client IP: " + strIp + " could not be " + "initialized and has been disconnected.");
    try {
      socket.close();
    } 
    catch (IOException e) {
      System.out.println("Client IP: " + strIp + " caused an error " + "while disconnecting.");
    } // try
  }// try

}//end constructor.

//-------------------------------------------------------------------------------------
public void run() {
//-------------------------------------------------------------------------------------
  char charBuffer[] = new char[1];
  String strXmlMsgOut;
  String strAction;
  String strData;
  
  try {
    System.out.println( "--------------------------------------------");
    System.out.println( "Client's run() executed." );
    System.out.println( "--------------------------------------------");
    
    BufferedOutputStream objOutStream = new BufferedOutputStream(socket.getOutputStream());
    
    while(objInStream.read(charBuffer,0,1) != -1) {
      
      StringBuffer objStringBuffer = new StringBuffer(8192);
    
      while(charBuffer[0] != '\0') {
              objStringBuffer.append(charBuffer[0]);
              objInStream.read(charBuffer, 0 ,1);
      }

      String strXmlMsgIn = objStringBuffer.toString();
      System.out.println("---Client: strXmlMsgIn = " + strXmlMsgIn);

      if ( strXmlMsgIn.length() > 0 ) {
      	
 	      strAction =    getXmlElement( strXmlMsgIn, ELEMENT_ACTION );
 	      strData   =    getXmlElement( strXmlMsgIn, ELEMENT_DATA );

        System.out.println("---Client: strAction=" + strAction + ", strData=" + strData);
 	      
 	      if (strAction.toLowerCase().equals( "javaconsole" ) ) {
 	      	
 	      	System.out.println( strData );
 	      	
          strXmlMsgOut = buildServerXml(this.STRSERVER_VALIDRESPONSE_CODE,
                                        "From Server: " + strData );
                                        
        } else {
          strXmlMsgOut = buildServerXml(this.STRSERVER_INVALIDRESPONSE_CODE, 
                                        this.STRSERVER_INVALIDRESPONSE_MSG);
        }
        
      } else {
        strXmlMsgOut = buildServerXml(this.STRSERVER_INVALIDRESPONSE_CODE, 
                                      this.STRSERVER_INVALIDRESPONSE_MSG);
      }

      System.out.println("---Client: sendXml() with: " + strXmlMsgOut);
      sendXml(strXmlMsgOut);

    } //while
  
  } catch(IOException ioe) {
    System.out.println("---Client IP: " + strIp + " - caused a read error.  Socket connect has been disconnected.");
  } //try
        
} //run

//-------------------------------------------------------------------------------------
private String buildServerXml( String strCode, String strMsg) {
//-------------------------------------------------------------------------------------
  String strXml = "";

  strXml = "<server msg=\"" + strMsg + "\" code=\"" + strCode + "\" />";
  
  return strXml;
}
//-------------------------------------------------------------------------------------
private String getIP() {
//-------------------------------------------------------------------------------------
  return this.strIp;
}

//-------------------------------------------------------------------------------------
private void sendXml(String strXml) {
//-------------------------------------------------------------------------------------

  objOutStream.write(strXml + "\0");
  
  if( objOutStream.checkError() ) {
    System.out.println("Client IP: " + strIp + " caused a write error and has been disconnected.");
  }
}

//-------------------------------------------------------------------------------------
private String getXmlElement( String strXml, String strElement ) {
//-------------------------------------------------------------------------------------
/*  Michael - This is a very cheap way to get the values but I was out of time
              and did not have JDOM setup yet.

*/

  boolean blnDebug = false;

  String strValue = "";
  int intStart = 0, intStop = 0;

  intStart = strXml.indexOf( strElement ) + strElement.length();
  if ( intStart >= 0 ) {
    intStop  = strXml.indexOf("\"", intStart);
  }

  if (intStart >= 0 && intStop > 0) {
    strValue = strXml.substring(intStart, intStop);
    if (blnDebug) System.out.println ( "Get: " + strElement + ", Found: " + strValue + 
                         ", substring(" + intStart + ", " + intStop + ")");
  } else {
    if (blnDebug) System.out.println ( "Error, cannot find element: " + strElement );
  }

  return strValue;
}

        
}//EOC
//EOF